\begin{exercise}{3.1}
  I've used the centered version of the dataset. The number of components that can be computed is 165, as the number of samples. Figure~\ref{fig:3.1} shows the results: on the main components individuals can be clearly recognized, while in higher components the shape of a face gradually decrease until only noise remains in the last component.
  \begin{figure}[h]
    \centering
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/0.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/1.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/2.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/3.png}
    \end{subfigure}
  
    \medskip
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/20.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/21.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/22.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/23.png}
    \end{subfigure}
  
    \medskip
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/80.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/81.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/82.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/83.png}
    \end{subfigure}
    
    \medskip
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/104.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/124.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/144.png}
    \end{subfigure}\hfil
    \begin{subfigure}{0.2\textwidth}
      \includegraphics[width=\linewidth]{\RootPathSheetThree/ex1/components-centered/164.png}
    \end{subfigure}
   
    \caption{some of the principal components computed from the YALE face dataset. From top line to bottom line: first 4 principal components; components~21~to~24; components~81~to~84; components~105-125-145-165.}
    \label{fig:3.1}
  \end{figure}
  \clearpage
  \pythoncode{\RootPathSheetThree/ex1/code.py}
\end{exercise}